<?
   class Template 
   {
	   private $filename;
	   private $params;
	   public function __construct($filename)
	   {
			$this->filename = $filename;
			$this->params = array();
	   }
	   public function setParam($key, $value)
	   {
		   $this->params[$key] = $value;
	   }
	   public function setParams($arr)
	   {
		   if (is_array($arr))
		   foreach($arr as $key => $value)
		      $this->setParam($key, $value);
	   }
	   public function getParam($key)
	   {
		   return isset($this->params[$key]) ? $this->params[$key] : null;
	   }
	   public function getTemplate()
	   {
		   extract($this->params);
		   ob_start();
		   include($this->filename);
		   return ob_get_clean();
	   }
	   public function displayTemplate()
	   {
		   echo $this->getTemplate();
	   }
   }
?>