<?
   class Users
   {
	   private $action;
	   private $id;
	   public function __construct($params)
	   {
		     if (isset($params[0]))
			 {
				 if (!strcmp((int)$params[0], $params[0]))
				 {
				 	$id = (int)$params[0];
 				 	$action = isset($params[1]) ? $params[1] : "view";
				 } else
					$action = $params[count($params) - 1];
			 }	else
			 	$action = "list";
			$this->action = $action;
			$this->id = $id;
	   }
	   public function Run()
	   {
		   $method = ucfirst($this->action)."Action";
		   if (method_exists($this, $method))
		   	 return $this->$method();
	   }
	   
	   private function ListAction()
	   {
	   }
	   
	   private function ViewAction()
	   {
	   }
	   
	   private function EditAction()
	   {
	   }  
	   public static function Panels()
	   {
		   if (isset($_SESSION['user']))
			   	$file = "design/Users/user-panel.tpl";
		   else
				$file = "design/Users/guest-panel.tpl";
   		   $tpl = new Template($file);
	   	   return array("users" => $tpl->getTemplate());
	   }
	   private function LogoutAction()
	   {
		   if (isset($_SESSION['user']))
			   unset($_SESSION['user']);
	   }
	   private function ProfileAction()
	   {
		   if ($_SERVER['REQUEST_METHOD'] == "POST")
		   {
			   $fields = array_form_filter($_POST, array("user_login", "user_password", "user_name", "user_surname"));
			   // проверяем, существует ли файл, имя которого записано в $_FILES['user_avatar']['tmp_name'] 
			   if (is_file($_FILES['user_avatar']['tmp_name']))
			   {
				   $avatarFile = "data/users/".uniqid().".jpg";
				   if (is_file($_SESSION['user']['user_avatar']))
					   unlink($_SESSION['user']['user_avatar']); // удаляем старый файл с изображением
				   move_uploaded_file($_FILES['user_avatar']['tmp_name'], $avatarFile);
				   $fields['user_avatar'] = $avatarFile;
			   }
			   $id = $_SESSION['user']['user_id'];
			   DB::Update("users", $fields, array("user_id" => $id));
			   $fields['user_id'] = $id;
			   $rows = DB::Select("users", array("*"), array("user_id" => $id));
			   $_SESSION['user'] = $rows[0];
			   header("Location: {$_SERVER['HTTP_REFERER']}");
			   die;
		   }
		   $tpl = new Template("design/Users/profile.tpl");
		   $title = "Редактирование профиля";
		   $tpl->setParams($_SESSION['user']);
		   $result["pageTitle"] = $title;
		   $result["pageContent"] = $tpl->getTemplate();
		   return $result;
	   }
	   private function LoginAction()
	   {
		   if (isset($_SESSION['user']))
			   return;
	   
		   if ($_SERVER['REQUEST_METHOD'] == "POST")
		   {
			   $fields = array_form_filter($_POST, array("user_login" , "user_password"));
			   if (DB::Count("users", $fields) > 0)
			   {
				  $rows = DB::Select("users", array("*"), $fields);
				  $_SESSION['user'] = $rows[0];
				  unset($_SESSION['user']['user_password']);
				  header("Location: /");
				  die;
			   } else
			   {
				  $loginError = "Ошибка ввода логина и пароля"; 
			   }
		   }
		   $tpl = new Template("design/Users/login.tpl");
		   $tpl->setParam("loginError", $loginError);
		   return array("pageTitle" => "Вход на сайт", "pageContent" => $tpl->getTemplate());  
	   }
	   private function SuccessAction()
	   {
		   $tpl = new Template("design/Users/success.tpl");
		   return array("pageTitle" => "Успешная регистрация", "pageContent" => $tpl->getTemplate());
	   }
	   
	   private function RegisterAction()
	   {
		   $result = array();
		   $tpl = new Template("design/Users/register.tpl");
		   if ($_SERVER['REQUEST_METHOD'] == "POST")
		   {
			   $fields = array_form_filter($_POST, array("user_login", "user_password", "user_name", "user_surname"));
			   if (DB::Count("users", array("user_login" => $fields["user_login"])) == 0)
			   {
			   	 DB::Insert("users", $fields);
				 header("Location: users/success");
			   }
			   else
			   {
				   $result['loginError'] = "Логин уже существует";
				   $tpl->setParams($fields);
			   }
		   }
		   $title = "Регистрация на сайте";
		   $result["pageTitle"] = $title;
		   $tpl->setParams($result);
		   $html = $tpl->getTemplate();
		   $result["pageContent"] = $html;
		   return $result;
	   }
	   
	   public function logIn()
	   {
		   
	   }
	   public function logOut()
	   {
		   
	   }
	   public function reg()
	   {
		   
	   }
	   public function edit()
	   {
		   
	   }
	   public function delete()
	   {
		   
	   }
   }
?>